<template>
  <div id="test">
    <b-container class="ct-workingtimes">
      <div v-if="this.add === false && this.edit === false">
        <b-row>
          <b-col cols="12">
            <b-table
              :current-page="currentPage"
              :per-page="perPage"
              :pagination="true"
              hover
              small
              :items="info"
              :fields="fields"
            >
              <template #cell(actions)="row" v-bind:info2="this.info2">
                <b-button
                  :disabled="info2 === 'user'"
                  size="sm"
                  variant="danger"
                  @click="deleteWork(row.item.id)"
                  class="mr-1"
                >
                  <b-icon icon="trash-fill" aria-hidden="true"></b-icon>
                </b-button>
              </template>
              <template #cell(edit)="row" v-bind:info2="this.info2">
                <b-button
                  :disabled="info2 === 'user'"
                  size="sm"
                  variant="primary"
                  @click="editWork(row.item.id)"
                  class="mr-1"
                >
                  <font-awesome-icon icon="edit" />
                </b-button>
              </template>
            </b-table>
          </b-col>
        </b-row>
        <b-row class="mb-1">
          <b-col cols="6">
            <b-pagination
              v-model="currentPage"
              :total-rows="info.length"
              :per-page="perPage"
              align="fill"
              size="sm"
              class="my-0"
            ></b-pagination>
          </b-col>
        </b-row>
      </div>
      <div v-if="this.add === true">
        <div id="add">
          <h1>Add your time</h1>
          <b-container fluid>
            <div id="user">
              <label for="input-default" id="space">Username:</label>
              <b-form-select
                v-model="user"
                :options="mappedInfos"
              ></b-form-select>
              <!-- <b-dropdown id="dropdown" offset="25" text="Offset Dropdown" class="m-2" variant="primary">
                  <b-dropdown-item href="#" v-for="value in infos" :key="value" >{{value.id}} - {{value.username}}</b-dropdown-item>
                </b-dropdown> -->
            </div>
            <div id="start">
              <label for="input-default">Start time:</label>
              <datetime type="datetime" v-model="start"></datetime>
            </div>
            <div id="end">
              <label for="input-default">End time:</label>
              <datetime type="datetime" v-model="end"></datetime>
            </div>
          </b-container>
          <b-button variant="success" @click="addWorks()">
            <b-icon icon="calendar-plus" aria-hidden="true"></b-icon>
            Add workingtimes
          </b-button>
        </div>
      </div>
      <div v-if="this.edit === true">
        <div id="edit">
          <h1>Edit working time</h1>
          <b-container fluid id="parent">
            <div id="start">
              <label for="input-default">Start time:</label>
              <datetime type="datetime" v-model="start"></datetime>
            </div>
            <div id="end">
              <label for="input-default">End time:</label>
              <datetime type="datetime" v-model="end"></datetime>
            </div>
          </b-container>
          <b-button variant="success" @click="editWorks()">
            Edit workingtime
          </b-button>
        </div>
      </div>
    </b-container>
  </div>
</template>
<script>
import { PaginationPlugin } from "bootstrap-vue";
Vue.use(PaginationPlugin);
// import vuescroll from "vuescroll";
import axios from "axios";
import { LayoutPlugin } from "bootstrap-vue";
Vue.use(LayoutPlugin);
import moment from "moment";
import { BButton } from "bootstrap-vue";

import Vue from "vue";
import vuescroll from "vuescroll";
import "bootstrap/dist/css/bootstrap.css";
import "bootstrap-vue/dist/bootstrap-vue.css";
import "vue-datetime/dist/vue-datetime.css";
import { Datetime } from "vue-datetime";
import { getUserId } from "@/router/auth.js";
import config from "@/Utils/config.json";
import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { faTrash, faEdit } from "@fortawesome/free-solid-svg-icons";
import { library } from "@fortawesome/fontawesome-svg-core";
Vue.component("datetime", Datetime);
Vue.component("b-button", BButton);
Vue.component("font-awesome-icon", FontAwesomeIcon);
library.add(faTrash);
library.add(faEdit);
import { IconsPlugin } from "bootstrap-vue";
Vue.use(IconsPlugin);
import { TablePlugin } from "bootstrap-vue";
Vue.use(TablePlugin);
Vue.component("vue-scroll", vuescroll);
import EventBus from "./EventBus";

export default {
  name: "Workingtimes",
  data() {
    return {
      info: {},
      username: "",
      infos: {},
      info2: "",
      mappedInfos: [],
      fields: [
        { key: "id", label: "ID" },
        { key: "user_id", label: "ID Utilisateur" },
        { key: "timeDuration", label: "Temps de travail" },
        { key: "dateWork", label: "Date" },
        { key: "actions", label: "Supprimer" },
        { key: "edit", label: "Editer" },
      ],
      add: false,
      end: "",
      currentPage: 1,
      pageOptions: [5, 10, 15],
      perPage: 5,
      start: "",
      pagination: true,
      user: "",
      edit: false,
      workid: "",
    };
  },
  methods: {
    onFiltered(filteredItems) {
      // Trigger pagination to update the number of buttons/pages due to filtering
      this.totalRows = filteredItems.length;
      this.currentPage = 1;
    },
    getTime(start, end) {
      return moment.substract(
        moment(end).diff(moment(start)).format("HH:mm:ss")
      );
    },
    totalHours(end, start) {
      const secs = moment(end).diff(start) / 1000;
      return moment.utc(secs * 1000).format("HH:mm:ss");
    },
    editWork(id) {
      this.edit = true;
      this.workid = id;
    },
    async editWorks() {
      this.edit = false;
      await axios.put(
        `${config.config.res_endpoint}api/workingtimes/${this.workid}`,
        {
          workingtime: {
            start: "" + moment.utc(this.start).local().format(),
            end: "" + moment.utc(this.end).local().format(),
          },
        },
        {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        }
      );
      await axios
        .get(`${config.config.res_endpoint}api/workingtimes/${getUserId()}`, {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        })
        .then(
          (response) => (this.info = this.transfornData(response.data.data))
        );
      this.start = "";
      this.end = "";
      EventBus.$emit("ADD_WORKS", { blabla: "addwork" });
    },
    deleteWork(id) {
      axios
        .delete(`${config.config.res_endpoint}api/workingtimes/${id}`, {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        })
        .then(() => {
          const newInfo = this.getWorks();
          this.info = newInfo;
        });
      EventBus.$emit("ADD_WORKS", { blabla: "addwork" });
    },
    getWorks() {
      return axios
        .get(`${config.config.res_endpoint}api/workingtimes/${getUserId()}`, {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        })
        .then(
          (response) => (this.info = this.transfornData(response.data.data))
        );
    },
    time2sec(val) {
      var pad = function (num, size) {
          return ("000" + num).slice(size * -1);
        },
        time = parseFloat(val).toFixed(3),
        hours = Math.floor(time / 60 / 60),
        minutes = Math.floor(time / 60) % 60,
        seconds = Math.floor(time - minutes * 60);

      return pad(hours, 2) + ":" + pad(minutes, 2) + ":" + pad(seconds, 2);
    },
    transfornData(data) {
      moment.locale("fr");
      var tmp = data;
      var arrayTime = [];
      for (let index = 0; index < tmp.length; index++) {
        var startDate = new Date(tmp[index].start);
        var endDate = new Date(tmp[index].end);
        var date = new Date(tmp[index].end);
        var dateWork = moment(date).format("DD/MM/YYYY");
        var tmpTime = (endDate.getTime() - startDate.getTime()) / 1000;
        arrayTime.push({
          timeDuration: this.time2sec(tmpTime),
          id: tmp[index].id,
          user_id: tmp[index].user_id,
          dateWork: dateWork,
        });
      }
      localStorage.setItem("timeValue", JSON.stringify(arrayTime));
      return arrayTime;
    },
    addWork() {
      this.add = true;
    },
    async addWorks() {
      this.add = false;
      if (!this.user && !this.start && !this.end) return;
      const user = this.user;
      await axios.post(
        `${config.config.res_endpoint}api/workingtimes/${user}`,
        {
          workingtime: {
            start: "" + moment.utc(this.start).local().format(),
            end: "" + moment.utc(this.end).local().format(),
          },
        },
        {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        }
      );
      await axios
        .get(`${config.config.res_endpoint}api/workingtimes/${getUserId()}`, {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        })
        .then(
          (response) => (this.info = this.transfornData(response.data.data))
        );
      this.start = "";
      this.end = "";
      EventBus.$emit("ADD_WORKS", { blabla: "addwork" });
    },
  },
  mounted() {
    this.totalRows = this.info.length;
    axios
      .get(`${config.config.res_endpoint}api/workingtimes/${getUserId()}`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      })
      .then((response) => (this.info = this.transfornData(response.data.data)));

    EventBus.$on("STOP_CLOCK", () => {
      this.getWorks();
    });

    axios
      .get(`${config.config.res_endpoint}api/users`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      })
      .then((response) => {
        this.infos = response.data.data;
        this.mappedInfos = this.infos.map((info) => {
          return { value: info.id, text: info.username };
        });
      });
    axios
      .get(`${config.config.res_endpoint}api/users/${getUserId()}`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      })
      .then((response) => {
        this.info2 = response.data.role;
      });

    EventBus.$on("STOP_CLOCK", () => {
      this.getWorks();
    });
  },
  computed: {
    rows() {
      return this.info.length;
    },
  },
};
</script>

<style>
#add {
  border-color: black;
  border-width: 5px;
  border-style: solid;
  width: 50%;
  margin-left: 23%;
  background: lightgrey;
  overflow: auto;
}

#edit {
  border-color: black;
  border-width: 5px;
  border-style: solid;
  width: 50%;
  margin-left: 23%;
  background: lightgrey;
}

/* #list {
    display: flex;
    flex-direction: row;
    text-align: center;
    justify-content: center;
  } */

/* #test { */
/* border-color: black;
  border-width: 5px;
  border-style: solid; */
/* overflow: auto; */

/* width: 550px; */
/* padding-left: 8%; */
/* background: lightblue; */
/* } */

#overflow {
  overflow: auto;
  height: 30vh;
}

#list button {
  margin-bottom: 15px;
  /* margin-right: 5 px; */
}

#user {
  display: flex;
  flex-direction: row;
  margin-bottom: 10px;
  width: 300px;
  margin-left: 20%;
  /* justify-content: space-between; */
}
#start {
  display: flex;
  flex-direction: row;
  margin-bottom: 10px;
  margin-left: 20.5%;
}
#start label {
  width: 100px;
}
#end {
  display: flex;
  flex-direction: row;
  margin-bottom: 10px;
  margin-left: 20.5%;
}
#end label {
  width: 100px;
}
#color {
  /* background: red; */
  width: 100%;
  height: auto;
}
#space {
  /* margin-right: 13px; */
  margin-left: 18px;
}

#button {
  margin-top: 10px;
  margin-bottom: 10px;
}

#margin {
  margin-bottom: 10px;
}

#page {
  text-align: right;
  padding-bottom: 10px;
}

#dropdown {
  width: 100%;
  padding-right: 10px;
}

#edit button {
  margin-top: 15px;
  margin-bottom: 5px;
}
</style>